; #########################################################################

      .386
      .model flat, stdcall
      option casemap :none   ; case sensitive

; #########################################################################

      include \masm32\include\windows.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\masm32.inc
      include \masm32\include\Fpu.inc
      
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\Fpu.lib

; #########################################################################

        ;=============
        ; Local macros
        ;=============
  
        szText MACRO Name, Text:VARARG
          LOCAL lbl
            jmp lbl
              Name db Text,0
            lbl:
          ENDM
          
        ;=================
        ; Local prototypes
        ;=================
        WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
        
    .data
        IDC_EDIT1   dd 0
        IDC_EDIT2   dd 0
        IDC_EDIT3   dd 0
        IDC_EDIT4   dd 0
        IDC_EDIT5   dd 0
        IDC_EDIT6   dd 0
        IDC_EDIT7   dd 0
        IDC_EDIT8   dd 0
        IDC_EDIT9   dd 0
        IDC_STATIC  dd 0
        IDC_STATIC1 dd 0
        IDC_STATIC2 dd 0
        IDC_STATIC3 dd 0
        IDC_STATIC4 dd 0
        IDC_STATIC5 dd 0
        IDC_STATIC6 dd 0
        IDC_STATIC7 dd 0
        IDC_STATIC8 dd 0
        IDC_BUTTON1 dd 0
        hButn1      dd 0
        hButn2      dd 0
        hInstance   dd 0
        hIconImage  dd 0
        hIcon       dd 0
        dlgname     db "IDD_DIALOG1",0

        BGdropMsg   dd "46.5",0
        BGupCarbMsg   dd "5.2",0
        LantusDoseMsg   dd "08",0

    .data?
        ;BGdropMsg   dd ?
        ;BGupCarbMsg dd ?
        ;LantusDoseMsg dd ?
        BGMsg       dd ?
        BGcarbMsg   dd ?
        CarbMsg     dd ?
        HumaCarbDoseMsg dd ?
        HumaDoseMsg dd ?
        HumaMealDoseMsg dd ?

        BGdropReal   TBYTE ?
        BGupCarbReal TBYTE ?
        LantusDoseReal TBYTE ?
        BGReal       TBYTE ?
        BGcarbReal   TBYTE ?
        CarbReal     TBYTE ?
        HumaCarbDoseReal TBYTE ?
        HumaDoseReal TBYTE ?
        HumaMealDoseReal TBYTE ?


; #########################################################################

    .code

start:

      invoke GetModuleHandle, NULL
      mov hInstance, eax
      
      ; -------------------------------------------
      ; Call the dialog box stored in resource file
      ; -------------------------------------------
      invoke DialogBoxParam,hInstance,ADDR dlgname,0,ADDR WndProc,0

      invoke ExitProcess,eax

; #########################################################################

WndProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

      LOCAL Ps :PAINTSTRUCT

      .if uMsg == WM_INITDIALOG
      
        szText dlgTitle," Dose Calculator"
        invoke SendMessage,hWin,WM_SETTEXT,0,ADDR dlgTitle

        invoke LoadIcon,hInstance,200
        mov hIcon, eax

        invoke SendMessage,hWin,WM_SETICON,1,hIcon

        invoke GetDlgItem,hWin,101
        mov IDC_EDIT1, eax

        invoke GetDlgItem,hWin,102
        mov IDC_EDIT2, eax

        invoke GetDlgItem,hWin,103
        mov IDC_EDIT3, eax

        invoke GetDlgItem,hWin,104
        mov IDC_EDIT4, eax

        invoke GetDlgItem,hWin,105
        mov IDC_EDIT5, eax

        invoke GetDlgItem,hWin,106
        mov IDC_EDIT6, eax

        invoke GetDlgItem,hWin,107
        mov IDC_EDIT7, eax

        invoke GetDlgItem,hWin,108
        mov IDC_EDIT8, eax

        invoke GetDlgItem,hWin,109
        mov IDC_EDIT9, eax

        invoke GetDlgItem,hWin,110
        mov IDC_STATIC, eax

        invoke GetDlgItem,hWin,111
        mov IDC_STATIC1, eax

        invoke GetDlgItem,hWin,112
        mov IDC_STATIC2, eax

        invoke GetDlgItem,hWin,113
        mov IDC_STATIC3, eax

        invoke GetDlgItem,hWin,114
        mov IDC_STATIC4, eax

        invoke GetDlgItem,hWin,115
        mov IDC_STATIC5, eax

        invoke GetDlgItem,hWin,116
        mov IDC_STATIC6, eax

        invoke GetDlgItem,hWin,117
        mov IDC_STATIC7, eax

        invoke GetDlgItem,hWin,118
        mov IDC_STATIC8, eax

        invoke GetDlgItem,hWin,119
        mov IDC_BUTTON1, eax

        xor eax, eax
        ret

      .elseif uMsg == WM_COMMAND
       .if wParam == 119
            ;mov BGdropMsg,"0 ,46.5"
            ;mov BGupCarbMsg,"0 ,5.2"
            ;mov LantusDoseMsg,"0 ,08"
            
            invoke SetDlgItemText,hWin,102,ADDR BGdropMsg
            invoke SetDlgItemText,hWin,104,ADDR BGupCarbMsg
            invoke SetDlgItemText,hWin,101,ADDR LantusDoseMsg

            invoke GetDlgItemText,hWin,101,ADDR LantusDoseMsg,3
            invoke GetDlgItemText,hWin,102,ADDR BGdropMsg,5
            invoke GetDlgItemText,hWin,103,ADDR BGMsg,5
            invoke GetDlgItemText,hWin,104,ADDR BGupCarbMsg,5
            invoke GetDlgItemText,hWin,105,ADDR CarbMsg,5
            invoke GetDlgItemText,hWin,106,ADDR HumaMealDoseMsg,5
            invoke GetDlgItemText,hWin,107,ADDR HumaDoseMsg,5
            invoke GetDlgItemText,hWin,108,ADDR HumaCarbDoseMsg,5
            invoke GetDlgItemText,hWin,109,ADDR BGcarbMsg,5

            ;calculate HumaCarbDose = Carb / BGupCarb
            invoke FpuAtoFL, ADDR CarbMsg, ADDR CarbReal, DEST_MEM
            invoke FpuAtoFL, ADDR BGupCarbMsg, ADDR BGupCarbReal, DEST_MEM
            invoke FpuDiv, ADDR CarbReal, ADDR BGupCarbReal, ADDR HumaCarbDoseReal, SRC1_REAL or SRC2_REAL
            invoke FpuFLtoA, ADDR HumaCarbDoseReal, 3, ADDR HumaCarbDoseMsg, SRC1_REAL or SRC2_DIMM
            invoke SetDlgItemText,hWin,108,ADDR HumaCarbDoseMsg

            ;calculate BGcarb = HumaCarbDose * BGdrop
            invoke FpuAtoFL, ADDR HumaCarbDoseMsg, ADDR HumaCarbDoseReal, DEST_MEM
            invoke FpuAtoFL, ADDR BGdropMsg, ADDR BGdropReal, DEST_MEM
            invoke FpuMul, ADDR HumaCarbDoseReal, ADDR BGdropReal, ADDR BGcarbReal, SRC1_REAL or SRC2_REAL
            invoke FpuFLtoA, ADDR BGcarbReal, 3, ADDR BGcarbMsg, SRC1_REAL or SRC2_DIMM
            invoke SetDlgItemText,hWin,109,ADDR BGcarbMsg

        ;.elseif wParam == 109
        ;    szText clearMsg,"109"
        ;    invoke MessageBox,hWin,ADDR clearMsg,
        ;                      ADDR dlgTitle,MB_OK
        .endif

      .elseif uMsg == WM_CLOSE
        invoke EndDialog,hWin,0

      .elseif uMsg == WM_PAINT
        invoke BeginPaint,hWin,ADDR Ps
      ; ----------------------------------------
      ; The following function are in MASM32.LIB
      ; ----------------------------------------
      ;  invoke FrameGrp,hButn1,hButn2,6,1,0
      ;  invoke FrameGrp,hEdit1,hEdit3,4,1,0
      ;  invoke FrameCtrl,hEdit4,4,1,0
        invoke FrameWindow,hWin,0,1,1
        invoke FrameWindow,hWin,1,1,0

        invoke EndPaint,hWin,ADDR Ps
        xor eax, eax
        ret

      .endif

    xor eax, eax    ; this must be here in NT4
    ret

WndProc endp

; ########################################################################

end start
